Package: EMTscoreData
Title: Single-cell RNA-seq datasets of EMT responses from Cook et al.
        (2020)
Version: 1.0.0
Authors@R: c(person("Haimei", "Wen", email = "hudie.luoluo@gmail.com", role = c("aut", "cre"),
    comment = c(ORCID = "0009-0006-1600-1210")),
    person("Tian", "Hong",
           role = "fnd"))
Description: Provides 12 single-cell RNA-seq datasets profiling epithelial–mesenchymal transition (EMT) in human cancer cell lines (MCF7, OVCA420, DU145, and A549) under TGF-beta stimulation, kinase inhibition, and time-course conditions, as reported by Cook DP and Vanderhyden BC (2020). The datasets are distributed via ExperimentHub as SingleCellExperiment objects.
License: GPL-3
Imports: SummarizedExperiment, Seurat, SingleCellExperiment,
        AnnotationHub, ExperimentHub, ggplot2
Suggests: BiocFileCache, SeuratObject, knitr, rmarkdown, googledrive,
        BiocStyle, testthat (>= 3.0.0)
VignetteBuilder: knitr
biocViews: ExperimentHub, SingleCellData, ExpressionData, CancerData,
        RNASeqData
URL: https://github.com/wenmm/EMTscoreData
BugReports: https://github.com/wenmm/EMTscoreData/issues
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-05-05 15:18:23 UTC; biocbuild
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/EMTscoreData
git_branch: RELEASE_3_23
git_last_commit: 25d2ca8
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-05-05
Author: Haimei Wen [aut, cre] (ORCID: <https://orcid.org/0009-0006-1600-1210>),
  Tian Hong [fnd]
Maintainer: Haimei Wen <hudie.luoluo@gmail.com>

## EMTscoreData

**EMTscoreData** is an R data package that provides curated gene expression datasets for benchmarking and developing epithelial–mesenchymal transition (EMT) scoring methods. This package is prepared as the companion dataset for the upcoming **EMTscore** R package.

### Overview

EMTscoreData includes processed expression data and metadata derived from the public dataset:

**GSE147405 (Cook et al.)**  
https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE147405

This study performed a **MULTI-seq pooled experiment** using four human epithelial cancer cell lines:

- **A549**
- **DU145**
- **MCF7**
- **OVCA420**

Cells were treated with **TGFB1**, **EGF**, or **TNF** for multiple time periods to capture dynamic changes related to EMT and cellular state transitions.

### Package Contents

The package provides:

- Processed gene expression matrices (e.g., log-normalized counts)
- Cell-level metadata including:
  - cell line  
  - treatment  
  - time point  
- Objects are stored in R-friendly formats as SingleCellExperiment (.rda) objects for convenient downstream analysis.

These datasets are ready to use for:
- EMT scoring method development
- Benchmarking EMT/MET signatures

### Installation

Install from GitHub:

```r
# install.packages("devtools")
devtools::install_github("wenmm/EMTscoreData")
```

### Data Source and Citation

The dataset included in this package is derived from:

**Cook DP, et al.**  
*Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional response. Nat Commun 2020 May 1;11(1):2142. PMID: 32358524*  
GEO accession: **GSE147405**  

If you use **EMTscoreData** in your work, please cite both **Cook DP, et al.** and the **EMTscore** package (once it is published).

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines MCF7 treated with TNF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load MCF7 TNF dataset
#' MCF7_TNF <- eh[["EH10282"]]
#' 
#' @return SingleCellExperiment dataset
#' @name MCF7_TNF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines MCF7 treated with EGF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load MCF7 EGF dataset
#' MCF7_EGF <- eh[["EH10283"]]
#' 
#' @return SingleCellExperiment dataset
#' @name MCF7_EGF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines MCF7 treated with TGFB1
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load MCF7 TGFB1 dataset
#' MCF7_TGFB1 <- eh[["EH10284"]]
#' 
#' @return SingleCellExperiment dataset
#' @name MCF7_TGFB1
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines OVCA420 treated with TNF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load OVCA420 TNF dataset
#' OVCA420_TNF <- eh[["EH10285"]]
#' 
#' @return SingleCellExperiment dataset
#' @name OVCA420_TNF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines OVCA420 treated with EGF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load OVCA420 EGF dataset
#' OVCA420_EGF <- eh[["EH10286"]]
#' 
#' @return SingleCellExperiment dataset
#' @name OVCA420_EGF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines OVCA420 treated with TGFB1
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load OVCA420 TGFB1 dataset
#' OVCA420_TGFB1 <- eh[["EH10287"]]
#' 
#' @return SingleCellExperiment dataset
#' @name OVCA420_TGFB1
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines DU145 treated with TNF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load DU145 TNF dataset
#' DU145_TNF <- eh[["EH10288"]]
#' 
#' @return SingleCellExperiment dataset
#' @name DU145_TNF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines DU145 treated with EGF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load DU145 EGF dataset
#' DU145_EGF <- eh[["EH10289"]]
#' 
#' @return SingleCellExperiment dataset
#' @name DU145_EGF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines DU145 treated with TGFB1
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load DU145 TGFB1 dataset
#' DU145_TGFB1 <- eh[["EH10290"]]
#' 
#' @return SingleCellExperiment dataset
#' @name DU145_TGFB1
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines A549 treated with TNF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load A549 TNF dataset
#' A549_TNF <- eh[["EH10291"]]
#' 
#' @return SingleCellExperiment dataset
#' @name A549_TNF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines A549 treated with EGF
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat 
#' SingleCellExperiment ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load A549 EGF dataset
#' A549_EGF <- eh[["EH10292"]]
#' 
#' @return SingleCellExperiment dataset
#' @name A549_EGF
NULL

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in
#' human cancer cell lines A549 treated with TGFB1
#' 
#' Each dataset was processed into a SingleCellExperiment object and saved as
#' an .rda file.
#' 
#' @details
#' The datasets can be accessed via \code{ExperimentHub} using the provided
#' accessors. Each object contains gene expression matrices and associated
#' cell metadata, such as treatment.
#' 
#' @format SingleCellExperiment object containing scRNA-seq profiles for
#' cell line and treatment.
#' 
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. \emph{Nature Communications} 2020 May 1;11(1):2142.
#' @import AnnotationHub ExperimentHub Seurat SingleCellExperiment 
#' ggplot2 Seurat
#' @examples
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "EMTscoreData") 
#'
#' #Example: load A549 TGFB1 dataset
#' A549_TGFB1 <- eh[["EH10293"]]
#' 
#' @return SingleCellExperiment dataset
#' @name A549_TGFB1
NULL

.onLoad <- function(libname, pkgname) {
  fl <- system.file("extdata", "metadata.csv", package = pkgname)
  titles <- utils::read.csv(fl, stringsAsFactors = FALSE)$Title
  
  ExperimentHub::createHubAccessors(pkgname, 'MCF7_TNF')
  ExperimentHub::createHubAccessors(pkgname, 'MCF7_EGF')
  ExperimentHub::createHubAccessors(pkgname, 'MCF7_TGFB1')
  ExperimentHub::createHubAccessors(pkgname, 'OVCA420_TNF')
  ExperimentHub::createHubAccessors(pkgname, 'OVCA420_EGF')
  ExperimentHub::createHubAccessors(pkgname, 'OVCA420_TGFB1')
  ExperimentHub::createHubAccessors(pkgname, 'DU145_TNF')
  ExperimentHub::createHubAccessors(pkgname, 'DU145_EGF')
  ExperimentHub::createHubAccessors(pkgname, 'DU145_TGFB1')
  ExperimentHub::createHubAccessors(pkgname, 'A549_TNF')
  ExperimentHub::createHubAccessors(pkgname, 'A549_EGF')
  ExperimentHub::createHubAccessors(pkgname, 'A549_TGFB1')
}

#' EMTscoreData: Single-cell RNA-seq datasets for EMTscore
#' 
#' The EMTscoreData package provides 12 single-cell RNA-seq datasets from
#' Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
#' transcriptional response. Nature Communications 11(1):2142.
#' 
#' These datasets profile epithelial-mesenchymal transition (EMT) in multiple
#' human cancer cell lines (MCF7, OVCA420, DU145, A549) under TNF, EGF and 
#' TGFb1 treatment.
#' 
#' Each dataset is provided as a ".rda" file containing a SingleCellExperiment
#' object accessible via the ExperimentHub interface.
#' 
#' @section Datasets includes:
#' \itemize{
#' \item MCF7_TNF
#' \item MCF7_EGF
#' \item MCF7_TGFB1
#' \item OVCA420_TNF
#' \item OVCA420_EGF
#' \item OVCA420_TGFB1
#' \item DU145_TNF
#' \item DU145_EGF
#' \item DU145_TGFB1
#' \item A549_TNF
#' \item A549_EGF
#' \item A549_TGFB1
#' }
#' 
#' 
#' @format
#' Each resource is a \linkS4class{SingleCellExperiment} object with:
#' \itemize{
#'   \item \code{assays}: expression matrices 
#'   (e.g., \code{"counts"} and/or \code{"logcounts"}).
#'   \item \code{rowData}: gene-level annotation
#'   (identifiers and optional symbols).
#'   \item \code{colData}: cell-level metadata.
#' }
#' Resources are retrieved using \pkg{ExperimentHub} identifiers (EH IDs).
#' 
#' @source
#' Primary data source: GEO accession \code{GSE147405}. The datasets were 
#' curated from the study by Cook and Vanderhyden (2020) and made available
#' through \pkg{ExperimentHub} as part of this package.
#' source GEO accession: GSE147405
#' @importFrom ExperimentalHub EMTscoreData AnnotationHub ggplot2 Seurat
#' @references
#' Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
#' response. Nature Communications. 2020 May 1;11(1):2142. PMID: 32358524
#' 
#' @examples
#' library(ExperimentalHub)
#' library(EMTscoreData)
#' eh <- ExperimentHub()
#' mcf7_tgfb <- eh[["EH10284"]]

## ----install_github, eval=FALSE-----------------------------------------------
# # install.packages("devtools")
# #devtools::install_github("wenmm/EMTscore")
# #devtools::install_github("wenmm/EMTscoreData")

## ----install------------------------------------------------------------------
#if (!require("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")

#BiocManager::install("EMTscore")
#BiocManager::install("EMTscoreData")

## -----------------------------------------------------------------------------
library(EMTscoreData)
#library(EMTscore)
library(ExperimentHub)
library(SummarizedExperiment)
library(Seurat)
library(ggplot2)

## -----------------------------------------------------------------------------
eh <- ExperimentHub()
query(eh , 'EMTscoreData')

## -----------------------------------------------------------------------------
A549_TNF <- eh[['EH10291']]
A549_EGF <- eh[['EH10292']]
A549_TGFB1 <- eh[['EH10293']]

## -----------------------------------------------------------------------------
class(A549_TNF)
A549_TNF

## -----------------------------------------------------------------------------
#List available assays (common ones: "counts", "logcounts")
assayNames(A549_TNF)

## -----------------------------------------------------------------------------
#List available per-cell metadata fields
colnames(colData(A549_TNF))

## -----------------------------------------------------------------------------
set.seed(1)

subset_cells <- function(sce, n = 500) {
n <- min(n, ncol(sce))
sce[, sample(seq_len(ncol(sce)), n)]
}

A549_TNF_small <- subset_cells(A549_TNF, n = 1500)
A549_EGF_small <- subset_cells(A549_EGF, n = 1500)
A549_TGFB1_small <- subset_cells(A549_TGFB1, n = 1500)

objects <- list(
A549_TGFB1 = A549_TGFB1_small,
A549_EGF = A549_EGF_small,
A549_TNF = A549_TNF_small
)

#Confirm the reduced size

sapply(objects, ncol)

## -----------------------------------------------------------------------------
library(BiocFileCache)
url <- "https://zenodo.org/records/18168504/files/HALLMARK_EPITHELIAL_MESENCHYMAL_TRANSITION.v2025.1.Hs.gmt"

bfc <- BiocFileCache() # creates/uses a cache folder
gmt_file <- bfcrpath(bfc, url) # downloads once; returns the cached file path

## -----------------------------------------------------------------------------
read_gmt <- function(fname){
  #Read all lines from the GMT file
  gmt_lines <- readLines(fname)
  #Split each line by tab; each line becomes a character vector
  gmt_list <- lapply(gmt_lines, function(x) unlist(strsplit(x, split="\t")))
  #For each line, genes start at element 3 (after name and description)
  gmt_genes <- lapply(gmt_list, function(x) x[3:length(x)])
  #Get unique gene list
  genes <- unique(unlist(gmt_genes))
  #Return a data frame whose column name is `gene` and whose values are gene names.
  return(data.frame(gene = genes, stringsAsFactors = FALSE))
}

Genesets <- read_gmt(gmt_file)
Genesets

## -----------------------------------------------------------------------------
## ------------------------------------------------------------------
## Prepare input objects
## ------------------------------------------------------------------
## We first organize the datasets into a named list. Each element
## corresponds to one experimental condition and contains a Seurat
## object (or a SingleCellExperiment object that will be converted
## internally). This unified structure allows us to apply the same
## EMT scoring procedure to multiple datasets in a consistent way.

objects <- list(
A549_TGFB1 = A549_TGFB1_small,
A549_EGF   = A549_EGF_small,
A549_TNF   = A549_TNF_small
)

## EMT gene list extracted from the GMT file. These genes define
## the epithelial–mesenchymal transition (EMT) signature used
## for score calculation.
emt_genes <- Genesets$gene


## ------------------------------------------------------------------
## Function: add_EMT_score
## ------------------------------------------------------------------
## This function computes an EMT score for each cell in a collection
## of Seurat (or SingleCellExperiment) objects using a predefined
## EMT gene set.
##
## Input:
##   - objects: a named list of Seurat objects or SingleCellExperiment
##              objects. Each object represents one dataset or condition.
##   - gmt_file: path to a GMT file containing EMT-related genes.
##   - emt_name: name of the metadata column that will store the EMT score.
##
## Output:
##   - A list of Seurat objects, each containing a new metadata column
##     with one EMT score per cell.
##
## Note:
##   For demonstration purposes in this vignette, the EMT score is
##   calculated using Seurat's AddModuleScore function. More advanced
##   or alternative EMT scoring methods are implemented in the
##   companion EMTscore package.

add_EMT_score <- function(objects,
                          gmt_file,
                          emt_name = "EMT_Score") {
  
  ## Read the EMT gene set from the GMT file
  Genesets <- read_gmt(gmt_file)
  emt_genes <- Genesets$gene
  
  ## Apply EMT scoring to each object in the list
  obj_list <- lapply(names(objects), function(name) {
    
    obj <- objects[[name]]
    
    # Convert SCE → Seurat
    if (inherits(obj, "SingleCellExperiment")) {
      message("Converting SCE to Seurat: ", name)
      obj <- as.Seurat(obj, data = "logcounts")
    }
    if (!inherits(obj, "Seurat")) {
      stop("Object ", name, " is not a Seurat or SCE object.")
    }
    
    ## Update the Seurat object to the current structure if needed.
    obj <- UpdateSeuratObject(obj)
    
    # get gene expression matrix
    geneExp <- GetAssayData(obj, assay = "RNA", layer = "data")
    
    ## Compute the EMT score using the EMT gene set.
    ## AddModuleScore returns a column named '<emt_name>1', which we
    ## subsequently rename for clarity.
    obj <- AddModuleScore(obj, features = list(emt_genes), name = emt_name, ctrl = 5)
    old <- paste0(emt_name, "1")
    obj <- SeuratObject::AddMetaData(
      object   = obj,
      metadata = obj[[old]][, 1, drop = TRUE],  # 提取为向量
      col.name = emt_name
    )
    obj[[old]] <- NULL
    return(obj)
  })
  
  
  ## Preserve original dataset names
  names(obj_list) <- names(objects)
  return(obj_list)
}


## ------------------------------------------------------------------
## Function: plot_EMT_from_objects
## ------------------------------------------------------------------
## This function visualizes EMT scores as a function of pseudotime
## across multiple datasets.
##
## Input:
##   - obj_list: a list of Seurat objects produced by add_EMT_score().
##   - col_name: name of the metadata column representing pseudotime.
##   - emt_score_col: name of the metadata column storing EMT scores.
##
## Output:
##   - A ggplot object showing smoothed EMT score trends along pseudotime
##     for each experimental condition.

plot_EMT_from_objects <- function(obj_list, col_name,
                                  emt_score_col) {
  
  ## Merge metadata from all Seurat objects into a single data frame
  ## for visualization.
  plot_df <- do.call(rbind, lapply(names(obj_list), function(name) {
    obj <- obj_list[[name]]
    df <- obj[[]][, c(col_name, emt_score_col), drop = FALSE]
    colnames(df) <- c(col_name, emt_score_col)
    ## Track the experimental condition
    df$Condition <- name
    ## Order cells by pseudotime for smoother visualization
    df <- df[order(df[[col_name]]), ]  
    df
  }))
  
  # Draw smooth curves
  p <- ggplot(plot_df, aes_string(x = col_name, y = emt_score_col, 
                                  color = "Condition")) +
    geom_smooth(method = "loess", se = FALSE, linewidth = 1.2) +
    theme_classic(base_size = 14) +
    labs(x = col_name, y = emt_score_col, color = "Condition")
  
  return(p)
}

## ------------------------------------------------------------------
## Run EMT scoring and visualization
## ------------------------------------------------------------------
## Compute EMT scores for all datasets and visualize their dynamics
## along pseudotime.

seurat_objs <- add_EMT_score(objects, 
                             gmt_file = gmt_file,
                             emt_name = "EMT_score")
p_Seurat <- plot_EMT_from_objects(seurat_objs, 
                                  col_name = "Pseudotime", 
                                  emt_score_col = "EMT_score")
p_Seurat

## -----------------------------------------------------------------------------
sessionInfo()

library(googledrive)

drive_deauth()

drive_user()

#public_file <-  drive_get(as_id("1vj607etanUVYzVFj_HXkznHTd0Ltv_Y4"))
#drive_download(public_file, overwrite = TRUE)

folder_url <- "https://drive.google.com/drive/folders/1SIEIf7UswTv_0S6TypYsaRzMcfkfsgji"

files <- drive_ls(as_id(folder_url))

rds_files <- files[grepl("\\.rds$", files$name, ignore.case = TRUE) &
                     !grepl("Kinase", files$name, ignore.case = TRUE), ]

local_dir <- "data-raw/downloaded"
if (!dir.exists(local_dir)) dir.create(local_dir, recursive = TRUE)

for(i in seq_len(nrow(rds_files))) {
  file_name <- rds_files$name[i]
  file_id <- rds_files$id[i]
  dest <- file.path(local_dir, file_name)

  message("Downloading ", file_name, " ...")
  drive_download(as_id(file_id), path = dest, overwrite = TRUE)
}

library(Seurat)
library(SingleCellExperiment)

# rds file path
input_dir <- "data-raw/downloaded"
output_dir <- "data-raw/downloaded"

# If the output directory does not exist, create it automatically.
if(!dir.exists(output_dir)) dir.create(output_dir, recursive = TRUE)

# Get all RDS
files <- list.files(input_dir, pattern = "\\.rds$", full.names = TRUE)

for (f in files) {
  message("Processing: ", f)
  
  # Construct full path and read Seurat object
  seurat_obj <- readRDS(f)
  seurat_obj <- UpdateSeuratObject(seurat_obj)
  
  # Convert to SingleCellExperiment
  sce_obj <- as.SingleCellExperiment(seurat_obj)
  
  # Use file name prefix as variable name
  var_name <- tools::file_path_sans_ext(basename(f))
  assign(var_name, sce_obj)
  
  # Save as .rda
  out_path <- file.path(output_dir, paste0(var_name, ".rda"))
  save(list = var_name, file = out_path)
  
  message("Saved: ", out_path)
}

### =========================================================================
### EMTscoreData metadata
### -------------------------------------------------------------------------
###

meta <- data.frame(
  Title = c("MCF7_TNF.rda",
            "MCF7_EGF.rda",
            "MCF7_TGFB1.rda",
            "OVCA420_TNF.rda",
            "OVCA420_EGF.rda",
            "OVCA420_TGFB1.rda",
            "DU145_TNF.rda",
            "DU145_EGF.rda",
            "DU145_TGFB1.rda",
            "A549_TNF.rda",
            "A549_EGF.rda",
            "A549_TGFB1.rda"),
  Location_Prefix = rep("https://zenodo.org/", 12),
  Description = c("MCF7 cells treated with TNF for various periods of time",
                  "MCF7 cells treated with EGF for various periods of time",
                  "MCF7 cells treated with TGFB1 for various periods of time",
                  "OVCA420 cells treated with TNF for various periods of time",
                  "OVCA420 cells treated with EGF for various periods of time",
                  "OVCA420 cells treated with TGFB1 for various periods of time",
                  "DU145 cells treated with TNF for various periods of time",
                  "DU145 cells treated with EGF for various periods of time",
                  "DU145 cells treated with TGFB1 for various periods of time",
                  "A549 cells treated with TNF for various periods of time",
                  "A549 cells treated with EGF for various periods of time",
                  "A549 cells treated with TGFB1 for various periods of time"),
  BiocVersion = rep("3.21", 12),
  Genome = rep("Homo sapiens", 12),
  SourceType = rep("RDA", 12),
  SourceUrl = c("https://zenodo.org/records/18168504/files/MCF7_TNF.rda",
                "https://zenodo.org/records/18168504/files/MCF7_EGF.rda",
                "https://zenodo.org/records/18168504/files/MCF7_TGFB1.rda",
                "https://zenodo.org/records/18168504/files/OVCA420_TNF.rda",
                "https://zenodo.org/records/18168504/files/OVCA420_EGF.rda",
                "https://zenodo.org/records/18168504/files/OVCA420_TGFB1.rda",
                "https://zenodo.org/records/18168504/files/DU145_TNF.rda",
                "https://zenodo.org/records/18168504/files/DU145_EGF.rda",
                "https://zenodo.org/records/18168504/files/DU145_TGFB1.rda",
                "https://zenodo.org/records/18168504/files/A549_TNF.rda",
                "https://zenodo.org/records/18168504/files/A549_EGF.rda",
                "https://zenodo.org/records/18168504/files/A549_TGFB1.rda"),
  SourceVersion = rep("June 11 2019", 12),
  Species = rep("Homo sapiens", 12),
  TaxonomyId = rep(9606, 12),
  Coordinate_1_based = rep(TRUE, 12),
  DataProvider = rep("David P. Cook", 12),
  Maintainer = rep("David P. Cook <dpcook.lab@gmail.com>", 12),
  RDataClass = rep("SingleCellExperiment", 12),
  DispatchClass = rep("Rda", 12),
  RDataPath = c("records/18168504/files/MCF7_TNF.rda",
                "records/18168504/files/MCF7_EGF.rda",
                "records/18168504/files/MCF7_TGFB1.rda",
                "records/18168504/files/OVCA420_TNF.rda",
                "records/18168504/files/OVCA420_EGF.rda",
                "records/18168504/files/OVCA420_TGFB1.rda",
                "records/18168504/files/DU145_TNF.rda",
                "records/18168504/files/DU145_EGF.rda",
                "records/18168504/files/DU145_TGFB1.rda",
                "records/18168504/files/A549_TNF.rda",
                "records/18168504/files/A549_EGF.rda",
                "records/18168504/files/A549_TGFB1.rda"),
  Tags = rep(paste("scRNA-seq;Homo sapiens;SingleCellExperiment;EMT"),12))

write.csv(meta, file="inst/extdata/metadata.csv", row.names=FALSE)

test_that("Example resource downloads and is SingleCellExperiment", {
  testthat::skip_if_offline()
  
  eh <- ExperimentHub::ExperimentHub()
  sce <- eh[["EH10291"]]   # 换成你包里稳定存在的那个 ID
  
  testthat::expect_s4_class(sce, "SingleCellExperiment")
})

test_that("Resource has expected assays and metadata fields", {
  testthat::skip_if_offline()
  
  eh <- ExperimentHub::ExperimentHub()
  sce <- eh[["EH10291"]]
  
  # assay 名称按你的实际情况选：counts/logcounts 其中至少一个
  testthat::expect_true(any(SummarizedExperiment::assayNames(sce) %in% c("counts", "logcounts")))
})

test_that("ExperimentHub records can be queried", {
  testthat::skip_if_offline()
  
  eh <- ExperimentHub::ExperimentHub()
  q <- AnnotationHub::query(eh, "EMTscoreData")
  
  testthat::expect_true(length(q) > 0)
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{DU145_TGFB1}
\alias{DU145_TGFB1}
\title{EMTscoreData: Single-cell RNA-seq datasets for EMTscore}
\format{
SingleCellExperiment object containing scRNA-seq profiles for
cell line and treatment.
}
\value{
SingleCellExperiment dataset
}
\description{
The EMTscoreData package provides 12 single-cell RNA-seq datasets from
Cook DP, Vanderhyden BC (2020). Context specificity of the EMT
transcriptional response. Nature Communications 11(1):2142.
}
\details{
These datasets profile epithelial-mesenchymal transition (EMT) in
human cancer cell lines DU145 treated with TGFB1

Each dataset was processed into a SingleCellExperiment object and saved as
an .rda file.


The datasets can be accessed via \code{ExperimentHub} using the provided
accessors. Each object contains gene expression matrices and associated
cell metadata, such as treatment.
}
\examples{
library(ExperimentHub)
eh <- ExperimentHub()
query(eh, "EMTscoreData") 

#Example: load DU145 TGFB1 dataset
DU145_TGFB1 <- eh[["EH10290"]]

}
\references{
Cook DP, Vanderhyden BC. Context specificity of the EMT transcriptional
response. \emph{Nature Communications} 2020 May 1;11(1):2142.
}
